var portNative = null;
var portFromCS = null;
var versionExtension = "1.0.0.1";

function responseCallback (message){
	if (portFromCS != null)
		portFromCS.postMessage(message);
}

function onNativeMessage(message) {
	responseCallback({ data: message });
    return false;
}

function onDisconnected(p) {
	try	{
		portNative = null;
		responseCallback({ data: { result: "disconnected" } });
	}
	catch(e){
		console.log(`background error: ${e}`);
		responseCallback({ data: { result: "notInstalled" } });
	}
}


function postMessage(methodData) {
	try	{
		if(portNative == null) {
			portNative = browser.runtime.connectNative("com.taxcom.crypto_ax");
			portNative.onMessage.addListener(onNativeMessage);
			portNative.onDisconnect.addListener(onDisconnected);
		} 
		
		if(portNative == null) {
			responseCallback({ data: { result: "notInstalled" } });
			return false;
		}

		if(methodData != null)
			portNative.postMessage(methodData);
		else
			responseCallback({ data: { result: "empty data" } });
		
		return false;
	} 
	catch(e){
		console.log(`background error: ${e}`);
		responseCallback({ data: { result: "notInstalled" } });
	}
	return false;
}

function handleMessage(request) {
    try{
		if (request.methodName == "GetExtVersion") {
			responseCallback({ data: { result: versionExtension } });
			return false;
		} else 
			return postMessage(request);
	}catch(e){
		console.log(`background error: ${e}`);
		responseCallback({ data: { result: "notInstalled" } });
	}
	return false;
}
function connectedCS(p) {
	try{
		portFromCS = p;
		portFromCS.onMessage.addListener(handleMessage);
	} catch(e){
		console.log(`background error: ${e}`);
	}
}

function disconnectedCS(p) {
	try{
		portFromCS = null;
		
		if (portNative!=null){
			portNative.disconnect();
			portNative = null;
		}
		
	} catch(e){
		console.log(`background error: ${e}`);
	}
}

browser.runtime.onConnect.addListener(connectedCS);
browser.runtime.onDisconnect.addListener(disconnectedCS);